Description

FBX LOD - Feature Request

This feature, or set of features, would make high-poly 3D models a much more feasible option for mod creators by allowing creators
to squeeze in more detail with less impact on the users game performance.

User Personas
The 3D Model Creator

As a 3D mod creator, | need the ability to set varying levels of detail (or LOD) for the models | am creating. Each LOD would be tied
to a specific range of distances away from the player view.

This feature would potentially improve game performance by rendering the highest detailed version of models only at the closest

range and would progressively switch to lower detailed levels at greater distances, possibly reverting to sprites at the greatest
distance.

The Player

As a player, | desire good performance and frame rates while using mods that contain high polygon 3D models. A drop in frame rates
does negatively impact my gaming experience, and could dissuade me from using the offending mods.

As a player, having the option to set the maximum 3D model render distance would empower me to find a balance between model
details and performance.

As a player, having an option to limit the maximum number of models on screen would further empower me.

Feature Considerations

One acceptable solution would be to empower the mod creator to specify the distance that each detail level would be rendered and
specifying a max distance if desired. However, this does not account for differing capabilities of computers.

A better solution would be to empower the players with some control over this by providing a “3D Model Render Distance” setting in
the form of a slider. In this solution the mod creator would define a number of detail levels and the models used for each level. The
actual range of each level would respond to the user defined setting.

l.e., User sets the max render distance to 4,000 units, the object model contains 4 levels of detail, so LOD level 1 is rendered within

the nearest 1,000 units, level 2 is rendered within 1k and 2k units, Ivl 3 between 2k and 3k, Ivl 4 - 3k and 4K, and finally the object
reverts to its sprites beyond 4,000 units. If the creator did not specify LOD, only one level would be rendered within the 4,000 units.

Acceptance Criteria

1 - models with LOD, switch between detail levels as determined by the mod creator

2 - the feature is additive and does not render existing settings, mods, or models obsolete

3 - LOD levels scale within the user defined max render distance (see next)

4 - settings options for 3D Model maximum render distance (may require a separate feature request)

5 - settings option for maximum number of models rendered (may require a separate feature request)
Related issues:
Related to Feature #8: New GL2 based model renderer Closed 2013-10-11

History

#1 - 2021-02-17 20:54 - skyjake
- Assignee changed from Deng Team to skyjake

- Target version set to Rendering

Targeting "Rendering" for now because it's unclear where this will be released. | will likely work on it in the master/3.0 branch, but backporting to
2.3/2.4 may be an option.

#2 - 2021-02-17 20:54 - skyjake
- Related to Feature #8: New GL2 based model renderer added

#3 - 2021-02-17 21:38 - NiuHaka

That is great. I'm excited about the potential here.

Also, | decided not to create separate requests for the mentioned settings features because | don't see those as essential to the LOD feature. My
thinking was that I'd create those issues if that was the route you wanted to take.
